chiark / gitweb /
Merge remote-tracking branch 'spwhitton/maint-merge-updates' into fix
[dgit.git] / tests / lib
1 #
2
3 exec 2>&1
4 set -x
5 set -o pipefail
6
7 . tests/lib-core
8 . tests/lib-restricts
9
10 t-report-failure () {
11         set +x
12         rc=$1
13         cat <<END >&2
14 TEST FAILED
15 funcs: ${FUNCNAME[*]}
16 lines: ${BASH_LINENO[*]}
17 files: ${BASH_SOURCE[*]}
18 END
19         exit 16
20 }
21
22 trap 'test $? = 0 || t-report-failure' EXIT
23
24 t-filter-out-git-hyphen-dir
25
26 t-set-intree
27
28 : ${DGIT_TEST_DEBUG=-D}
29 export DGIT_TEST_DEBUG
30
31 export GIT_COMMITTER_DATE='1440253867 +0100'
32 export GIT_AUTHOR_DATE='1440253867 +0100'
33
34 root=`pwd`
35 troot=$root/tests
36 testname="${DGIT_TEST_TESTNAME-${0##*/}}"
37
38 tmp=$ADTTMP
39 if [ x"$tmp" = x ]; then
40         mkdir -p tests/tmp
41         tmpbase=$troot/tmp
42         tmp=tests/tmp/$testname
43         rm -rf $tmp
44         mkdir $tmp
45 elif [ "x$DGIT_TEST_TMPBASE" != x ]; then
46         tmpbase="$DGIT_TEST_TMPBASE"
47 fi
48 cd $tmp
49
50 tmp=`pwd`
51
52 t-set-using-tmp
53
54 env -0 >$tmp/.save-env
55
56 ln -f $troot/ssh ssh
57
58 export DEBCHANGE_VENDOR=dpkg
59
60 mkdir -p $tmp/incoming
61 cat <<END >$tmp/dput.cf
62 [test-dummy]
63 method                  = local
64 incoming                = $tmp/incoming
65 run_dinstall            = 0
66 END
67
68 : ${t_archive_method:=aq}
69 : ${tagpfx:=archive/test-dummy}
70 : ${suitespecs:=sid:unstable}
71
72 t-git-next-date () {
73         GIT_COMMITTER_DATE="$(( ${GIT_COMMITTER_DATE%% *} + 1 )) ${GIT_COMMITTER_DATE#* }"
74         GIT_AUTHOR_DATE="$GIT_COMMITTER_DATE"
75 }
76
77 t-expect-fail () {
78         local mpat="$1"; shift
79
80         set +o pipefail
81         LC_MESSAGES=C "$@" 2>&1 | tee $tmp/t.output
82         local ps="${PIPESTATUS[*]}"
83         set -o pipefail
84
85         case $ps in
86         "0 0")  fail "command unexpectedly succeeded (instead of: $mpat)" ;;
87         *" 0")  ;;
88         *)      fail "tee failed"  ;;
89         esac
90
91         t-grep-mpat "$mpat" $tmp/t.output
92 }
93
94 t-grep-mpat () {
95         local mpat="$1"
96         local file="$2"
97
98         local grepper=fgrep
99         case "$mpat" in
100         [A-Z]:*)
101                 case "$mpat" in
102                 E:*)    grepper=egrep   ;;
103                 F:*)    grepper=fgrep   ;;
104                 *)      fail "bad mpat prefix in $mpat";;
105                 esac
106                 mpat=${mpat#[A-Z]:}
107                 ;;
108         esac
109
110         $grepper -e "$mpat" "$file" ||
111                 fail "message not found"
112 }
113
114 t-expect-push-fail () {
115         local mpat="$1"; shift
116
117         local triedpush=`git rev-parse HEAD`
118
119         t-reporefs pre-push
120         t-expect-fail "$mpat"  "$@"
121         t-reporefs post-push
122         diff $tmp/show-refs.{pre,post}-push
123
124         t-git-objects-not-present '' $triedpush
125
126         eval "$t_expect_push_fail_hook"
127 }
128
129 t-git-objects-not-present () {
130         # t-git-objects-not-present GITDIR|'' OBJID [...]
131         # specifying '' means the repo for package $p
132         local gitdir="${1-$dgitrepo}"
133         local obj
134         if ! [ -e "$gitdir" ]; then return; fi
135         for obj in "$@"; do
136                 GIT_DIR=$gitdir \
137                 t-expect-fail 'unable to find' \
138                 git cat-file -t $obj
139         done
140 }
141
142 t-reporefs () {
143         local whichoutput=$1; shift
144         local whichrepo=${1-$dgitrepo}
145         local outputfile="$tmp/show-refs.$whichoutput"
146         (set -e
147          exec >"$outputfile"
148          if test -d $whichrepo; then
149                 cd $whichrepo
150                 git show-ref |sort
151         fi)
152 }
153
154 t-untar () {
155         local tarfile=$1.tar
156         local edittree=$1.edit
157         if test -d "$edittree"; then
158                 cp -a "$edittree"/* .
159         else
160                 tar xf "$tarfile"
161         fi
162 }
163
164 t-worktree () {
165         rm -rf $p
166         t-untar $troot/worktrees/${p}_$1
167 }
168
169 t-select-package () {
170         p=$1
171         dgitrepo=$tmp/git/$p.git
172 }
173
174 t-git () {
175         t-select-package $1
176         v=$2
177         mkdir -p $tmp/git
178         local gs=$troot/git-srcs/${p}_$v.git
179         (set -e; cd $tmp/git; t-untar $gs)
180 }
181
182 t-git-none () {
183         mkdir -p $tmp/git
184         (set -e; cd $tmp/git; tar xf $troot/git-template.tar)
185 }
186
187 t-git-merge-base () {
188         git merge-base $1 $2 || test $? = 1
189 }
190
191 t-has-ancestor () {
192         # t-has-ancestor ANCESTOR
193         # (CHILD is implicit, HEAD)
194         local now=`git rev-parse HEAD`
195         local ancestor=`git rev-parse $1^{}`
196         local mbase=`t-git-merge-base $ancestor $now`
197         if [ x$mbase != x$ancestor ]; then
198                 fail "not ff $ancestor..$now, $mbase != $ancestor"
199         fi
200 }
201
202 t-has-parent-or-is () {
203         # t-has-parent-or-is CHILD PARENT
204         local child=$1
205         local parent=$2
206         local parents=$(git show --pretty=format:' %P %H ' "$child")
207         parent=$(git rev-parse "$parent~0")
208         case "$parents" in
209         *" $parent "*)  ;;
210         *)      fail "child $child lacks parent $parent" ;;
211         esac
212 }
213
214 t-prep-newpackage () {
215         t-select-package $1
216         v=$2
217         t-archive-none $p
218         t-git-none
219         t-worktree $v
220         cd $p
221         if ! git show-ref --verify --quiet refs/heads/master; then
222                 git branch -m dgit/sid master
223                 git remote rm dgit
224         fi
225         cd ..
226 }
227
228 t-archive-none () {
229         t-select-package $1
230         t-archive-none-$t_archive_method
231 }
232 t-archive-none-aq () {
233         mkdir -p $tmp/aq/dsc_in_suite $tmp/mirror/pool/main
234
235         : >$tmp/aq/suites
236         local jsondelim="["
237
238         local suitespec
239         for suitespec in $suitespecs; do
240                 local suite=${suitespec%%:*}
241                 local sname=${suitespec#*:}
242
243                 >$tmp/aq/package.$suite.$p
244                 t-aq-archive-updated $suite $p
245
246                 >$tmp/aq/package.new.$p
247                 t-aq-archive-updated new $p
248
249                 ln -sf $suite $tmp/aq/dsc_in_suite/$sname
250
251                 cat <<END >>$tmp/aq/suites
252 $jsondelim
253    {
254       "archive" : "ftp-master",
255       "codename" : "$suite",
256       "components" : [
257          "main",
258          "contrib",
259          "non-free"
260       ],
261       "name" : "$sname",
262       "dakname" : "$sname"
263 END
264
265                 jsondelim="   },"
266
267         done
268         cat <<END >>$tmp/aq/suites
269     }
270 ]
271 END
272 }
273
274 t-aq-archive-updated () {
275         local suite=$1
276         local p=$2
277         local suitedir=$tmp/aq/dsc_in_suite/$suite
278         mkdir -p $suitedir
279         perl <$tmp/aq/package.$suite.$p >$suitedir/$p -wne '
280                 use JSON;
281                 use strict;
282                 our @v;
283                 m{^(\S+) (\w+) ([^ \t/]+)/(\S+)} or die;
284                 push @v, {
285                         "version" => "$1",
286                         "sha256sum" => "$2",
287                         "component" => "$3",
288                         "filename" => "$4",
289                 };
290                 END {
291                         my $json = JSON->new->canonical();
292                         print $json->encode(\@v) or die $!;
293                 }
294         '
295 }
296
297 t-archive-process-incoming () {
298         local suite=$1
299         mv $tmp/incoming/${p}_* $tmp/mirror/pool/main/
300         t-archive-query "$suite"
301 }
302
303 t-archive-query () {
304         local suite=${1-sid}
305         local dscf=main/${p}_${v}.dsc
306         t-archive-query-$t_archive_method "$suite" "$p" "$v" "$dscf"
307 }
308 t-archive-query-aq () {
309         local suite=$1
310         local p=$2
311         local v=$3
312         local dscf=$4
313         local sha=`sha256sum <$tmp/mirror/pool/$dscf`
314         echo "${v} ${sha%  -} $dscf" >>$tmp/aq/package.$suite.${p}
315         t-aq-archive-updated $suite $p
316 }
317
318 t-archive () {
319         t-archive-none $1
320         v=$2
321         local dscf=${p}_$2.dsc
322         rm -f $tmp/mirror/pool/main/${p}_*
323         ln $troot/pkg-srcs/${p}_${2%-*}* $tmp/mirror/pool/main/
324         t-archive-query $suite
325         rm -rf $tmp/extract
326         mkdir $tmp/extract
327         (set -e; cd $tmp/extract; dpkg-source -x ../mirror/pool/main/$dscf)
328 }
329
330 t-git-dir-time-passes () {
331         touch -d 'last year' $dgitrepo
332 }
333
334 t-git-dir-check () {
335         local gitdir=$dgitrepo
336         case "$1" in
337         enoent)
338                 if test -e "$gitdir"; then fail "$gitdir exists"; fi
339                 return
340                 ;;
341         public) wantstat='7[75]5' ;;
342         secret) wantstat='7[70]0' ;;
343         *)      fail "$1 t-git-dir-check ?" ;;
344         esac
345         gotstat=`stat -c%a $gitdir`
346         case "$gotstat" in
347         *$wantstat) return ;;
348         *)      fail "$gitdir has mode $gotstat, expected $wantstat" ;;
349         esac
350 }
351
352 t-rm-dput-dropping () {
353         rm -f $tmp/${p}_${v}_*.upload
354 }
355
356 t-dgit () {
357         local dgit=${DGIT_TEST-dgit}
358         pwd
359         : '
360 {{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{'
361         $dgit --dgit=$dgit --dget:-u --dput:--config=$tmp/dput.cf \
362                 -dtest-dummy $DGIT_TEST_OPTS $DGIT_TEST_DEBUG \
363                 -k39B13D8A $t_dgit_xopts "$@"
364         : '}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}
365 '
366 }
367
368 t-diff-nogit () {
369         diff --exclude=.git --exclude=.pc -ruN $*
370 }
371
372 t-files-notexist () {
373         local f
374         for f in "$@"; do
375                 if [ -e $f ]; then
376                         fail "$f exists!"
377                 fi
378         done
379 }
380
381 t-cloned-fetched-good () {
382         t-diff-nogit ../extract/$p-${v%-*} .
383         t-clean-on-branch dgit/sid
384         t-refs-same-start
385         t-refs-same \
386                 refs/heads/dgit/sid \
387                 refs/remotes/dgit/dgit/sid
388         t-refs-notexist refs/dgit/unstable refs/remotes/dgit/dgit/unstable
389 }
390
391 t-output () {
392         printf "%s${1:+\n}" "$1" >$tmp/t.want
393         shift
394         "$@" >$tmp/t.got
395         diff $tmp/t.want $tmp/t.got
396 }
397
398 t-clean-on-branch () {
399         t-output "## $1" git status -b --porcelain
400 }
401
402 t-setup-done () {
403         local savevars=$1
404         local savedirs=$2
405         local importeval=$3
406
407         local import=IMPORT.${0##*/}
408         exec 4>$tmp/$import.new
409
410         local vn
411         for vn in $savevars; do
412                 perl >&4 -I. -MDebian::Dgit -e '
413                         printf "%s=%s\n", $ARGV[0], shellquote $ARGV[1]
414                 ' $vn "$(eval "printf '%s\n' \"\$$vn\"")"
415         done
416
417         (set -e; cd $tmp; tar cf $import.tar $savedirs)
418
419         printf >&4 "\n%s\n" "$importeval"
420
421         mv -f $tmp/$import.new $tmp/$import
422 }
423
424 t-setup-import () {
425         local setupname=$1
426
427         local setupsrc
428         local lock
429         if [ "x$tmpbase" = x ]; then
430                 # ADTTMP was set on entry to tests/lib, so we
431                 # are not sharing tmp area between tests
432                 setupsrc="$tmp"
433                 lock="$tmp/.dummy.lock"
434         else
435                 setupsrc="$tmpbase/$setupname"
436                 lock="$setupsrc.lock"
437         fi
438
439         local simport="$setupsrc/IMPORT.$setupname"
440
441         if ! [ -e "$simport" ]; then
442                 with-lock-ex -w "$lock" \
443                 xargs -0 -a $tmp/.save-env \
444                 bash -xec '
445                         cd "$1"; shift
446                         setupname="$1"; shift
447                         simport="$1"; shift
448                         if [ -e "$simport" ]; then exit 0; fi
449                         env - "$@" \
450                         "tests/setup/$setupname"
451                 ' x "$root" "$setupname" "$simport"
452         fi
453
454         if [ "x$setupsrc" != "x$tmp" ]; then
455                 (set -e; cd $tmp; tar xf "$simport.tar")
456         fi
457
458         . "$simport"
459 }
460
461 t-git-get-ref-exact () {
462         local ref=$1
463         # does not dereference, unlike t-git-get-ref
464         case "$ref" in
465         refs/*) ;;
466         *) fail "t-git-get-ref-exact bad $ref" ;;
467         esac
468         git for-each-ref --format='%(objectname)' "[r]efs/${ref#refs/}"
469 }
470
471 t-git-get-ref () {
472         local ref=$1
473         case "$ref" in
474         refs/*) ;;
475         *) fail "t-git-get-ref bad $ref" ;;
476         esac
477         (git show-ref -d $1 || test $? = 1) | perl -ne '
478                 $x = $1 if m#^(\w+) \Q'$1'\E(?:\^\{\})?$#;
479                 END { print "$x\n" if length $x; }
480         '
481 }
482
483 t-ref-same-exact () {
484         local name="$1"
485         local val=`t-git-get-ref-exact $name`
486         t-ref-same-val "$name" $val
487 }
488
489 t-ref-same () {
490         local name="$1"
491         local val=`t-git-get-ref $name`
492         t-ref-same-val "$name" $val
493 }
494
495 t-ref-head () {
496         local val=`git rev-parse HEAD`
497         t-ref-same-val HEAD $val
498 }
499
500 t-ref-same-val () {
501         local name="$1"
502         local val=$2
503         case "${t_ref_val-unset}" in
504         unset)          ;;
505         "$val")         ;;
506         *)              fail "ref varies: ($name)\
507  ${val:-nothing} != ${t_ref_val:-nothing} (${t_ref_names[*]})" ;;
508         esac
509         t_ref_val="$val"
510         t_ref_names+=("$name")
511 }
512
513 t-refs-same-start () {
514         unset t_ref_val
515         t_ref_names=()
516 }
517
518 t-refs-same () {
519         local g
520         for g in $*; do
521                 t-ref-same $g
522         done
523 }
524
525 t-refs-notexist () {
526         local val
527         for g in $*; do
528                 val=`t-git-get-ref $g`
529                 if [ "x$val" != x ]; then
530                         fail "ref $g unexpectedly exists ($val)"
531                 fi
532         done
533 }
534
535 t-v-tag () {
536         echo refs/tags/$tagpfx/${v//\~/_}
537 }
538
539 t-format-ref () {
540         git log -n1 --pretty=format:"$1" "$2"
541 }
542
543 t-sametree-parent () {
544         local ref=$1
545         local parent
546         local ctree=$(t-format-ref '%T' "$ref")
547         while :; do
548                 local psame=''
549                 for parent in $(t-format-ref '%P' "$ref"); do
550                         local ptree=$(t-format-ref '%T' "$parent")
551                         if [ "x$ptree" = "x$ctree" ]; then
552                                 psame+=" $parent"
553                         fi
554                 done
555                 case "$psame" in ""|" * *") break ;; esac
556                 ref="${psame# }"
557         done
558         echo "$ref"
559 }
560
561 t-check-pushed-master () {
562         local master=`t-git-get-ref refs/heads/master`
563         if [ x$master = x$t_ref_val ]; then return; fi
564         if [ x$master = x ]; then fail "failed to push master"; fi
565         # didn't update master, it must be not FF
566         local mbase=`t-git-merge-base $master $t_ref_val`
567         if [ x$mbase = x$master ]; then fail "failed to ff master"; fi
568 }
569
570 t-pushed-good () {
571         local branch=$1
572         local suite=${2:-sid}
573         t-refs-same \
574                 refs/heads/$branch
575         t-pushed-good-core
576 }
577         
578 t-pushed-good-core () {
579         t-ref-dsc-dgit
580         t-refs-same \
581                 `t-v-tag` \
582                 refs/remotes/dgit/dgit/$suite
583         t-refs-notexist \
584                 refs/heads/dgit/unstable \
585                 refs/remotes/dgit/dgit/unstable
586         (set -e; cd $dgitrepo
587          t-refs-same \
588                 refs/dgit/$suite \
589                 `t-v-tag`
590          ${t_check_pushed_master:- : NOT-DRS-NO-CHECK-PUSHED-MASTER}
591          t-refs-notexist \
592                 refs/dgit/unstable
593         )
594         git verify-tag `t-v-tag`
595 }
596
597 t-splitbrain-pushed-good--unpack () {
598         cd $tmp
599         rm -rf t-unpack
600         mkdir t-unpack
601         cd t-unpack
602         ln -s $tmp/mirror/pool/main/*.orig*.tar* .
603         ln -s $tmp/incoming/*.orig*.tar* . ||:
604         ln -s $incoming_dsc .
605         ln -s ${incoming_dsc/.dsc/.debian.tar}* .
606         dpkg-source "$@" -x *.dsc
607         cd */.
608         git init
609         git fetch ../../$p "refs/tags/*:refs/tags/*"
610 }
611
612 t-splitbrain-pushed-good--checkprep () {
613         git add -Af .
614         git rm --cached -r --ignore-unmatch .pc
615 }
616
617 t-splitbrain-pushed-good--checkdiff () {
618         local tag=$1
619         t-splitbrain-pushed-good--checkprep
620         t-output "" git diff --stat --cached $tag
621 }
622
623 t-splitbrain-pushed-good-start () {
624         dep14tag=refs/tags/test-dummy/${v//\~/_}
625         dgittag=$(t-v-tag)
626         t-output "" git status --porcelain
627         t-ref-head
628         t-refs-same $dep14tag
629         (set -e; cd $dgitrepo; t-refs-same $dep14tag)
630         git merge-base --is-ancestor $dep14tag $dgittag
631
632         t-refs-same-start
633         t-ref-same refs/heads/split.p
634         case "$(t-git-get-ref refs/heads/split.b)" in
635         "$t_ref_val") ;;
636         "$(git rev-parse refs/heads/split.p^0)") ;;
637         "$(git rev-parse refs/heads/split.p^1)") ;;
638         *) fail 'bad b/p' ;;
639         esac
640         t-pushed-good-core
641
642         t-incoming-dsc
643
644         t-splitbrain-pushed-good--unpack
645         t-splitbrain-pushed-good--checkdiff $dgittag
646 }
647 t-splitbrain-pushed-good-end-made-dep14 () {
648         t-splitbrain-pushed-good--checkdiff $dep14tag
649         cd $tmp/$p
650 }
651
652 t-splitbrain-rm-gitignore-patch () {
653         perl -i -pe '
654                 next unless $_ eq "auto-gitignore\n";
655                 die if $counter++;
656                 chomp;
657                 rename "debian/patches/$_", "../t-auto-gitignore" or die $!;
658                 $_ = "";
659         ' debian/patches/series
660 }
661
662 t-gbp-pushed-good () {
663         local suite=${1:-sid}
664         t-splitbrain-pushed-good-start
665
666         # Right, now we want to check that the maintainer tree and
667         # the dgit tree differ in exactly the ways we expect.  We
668         # achieve this by trying to reconstruct the maintainer tree
669         # from the dgit tree.
670
671         # So, unpack it withut the patches applied
672         t-splitbrain-pushed-good--unpack --skip-patches
673
674         # dgit might have added a .gitignore patch, which we need to
675         # drop and remove
676         t-splitbrain-rm-gitignore-patch
677
678         # Now the result should differ only in non-debian/ .gitignores
679         t-splitbrain-pushed-good--checkprep
680         git diff --cached --name-only $dep14tag >../changed
681         perl -ne '
682                 next if !m#^debian/# && m#(^|/)\.gitignore#;
683                 die "$_ mismatch";
684         ' <../changed
685
686         # If we actually apply the gitignore patch by hand, it
687         # should be perfect:
688         if [ -f ../t-auto-gitignore ]; then
689                 patch --backup-if-mismatch -p1 -u <../t-auto-gitignore
690         fi
691
692         t-splitbrain-pushed-good-end-made-dep14
693 }
694
695 t-unapplied-pushed-good () {
696         t-splitbrain-pushed-good-start
697         t-splitbrain-pushed-good--unpack --skip-patches
698         t-splitbrain-pushed-good-end-made-dep14
699 }
700
701 t-dpm-pushed-good () {
702         t-splitbrain-pushed-good-start
703         t-splitbrain-pushed-good--unpack
704         t-splitbrain-rm-gitignore-patch
705         t-splitbrain-pushed-good-end-made-dep14
706 }
707
708 t-commit-build-push-expect-log () {
709         local msg=$1
710         local mpat=$2
711         t-commit "$msg"
712         t-dgit build
713         LC_MESSAGES=C \
714         t-dgit push --new 2>&1 |tee $tmp/push.log
715         t-grep-mpat "$mpat" $tmp/push.log
716 }
717
718 t-822-field () {
719         local file=$1
720         local field=$2
721         perl -e '
722                 use Dpkg::Control::Hash;
723                 my $h = new Dpkg::Control::Hash allow_pgp=>1;
724                 $h->parse(\*STDIN,"'"$file"'");
725                 my $val = $h->{"'$field'"},"\n";
726                 die "'"$file $field"'" unless defined $val;
727                 print $val,"\n";
728         ' <$file
729 }
730
731 t-stunt-envvar () {
732         local var=$1
733         local tstunt=$2
734         eval '
735                 case "$'$var'" in
736                 "$tstunt:"*)    ;;
737                 *":$tstunt:"*)  ;;
738                 "")             '$var'="$tstunt" ;;
739                 *)              '$var'="$tstunt:$'$var'" ;;
740                 esac
741                 export '$var'
742         '
743 }
744
745 t-tstunt () {
746         local tstunt=$tmp/tstunt
747         t-stunt-envvar PATH $tstunt
748         t-stunt-envvar PERLLIB $tstunt
749         local f
750         for f in "$@"; do
751                 f="./$f"
752                 local d="$tstunt/${f%/*}"
753                 mkdir -p $d
754                 ln -sf "$troot/tstunt/$f" "$d"/.
755         done
756 }
757
758 t-tstunt-parsechangelog () {
759         t-tstunt dpkg-parsechangelog Dpkg/Changelog/Parse.pm
760 }
761
762 t-tstunt-lintian () {
763         t-tstunt lintian
764 }
765
766 t-tstunt-debuild () {
767         : ${DGIT_TEST_REAL_DEBUILD:=$(type -p debuild)}
768         export DGIT_TEST_REAL_DEBUILD
769         t-tstunt debuild
770 }
771
772 t-incoming-dsc () {
773         local dsc=${p}_${v}.dsc
774         incoming_dsc=$tmp/incoming/$dsc
775 }
776
777 t-ref-dsc-dgit () {
778         t-incoming-dsc
779         local val=`t-822-field $incoming_dsc Dgit`
780         perl -e '$_=shift @ARGV; die "Dgit $_ ?" unless m/^\w+\b/;' "$val"
781         t-ref-same-val $incoming_dsc "$val"
782 }
783
784 t-apply-diff () {
785         local v1=$1
786         local v2=$2
787         (cd $troot/pkg-srcs;
788          debdiff ${p}_${v1}.dsc ${p}_${v2}.dsc || test $? = 1) \
789          | patch -p1 -u
790 }
791
792 t-gbp-unapplied-pq2qc () {
793         # does `gbp pq export'
794         # commits the resulting debian/patches on  qc/BRANCH
795         # leaves us on qc/BRANCH (eg "qc/quilt-tip"))
796         # qc/BRANCH is not fast-forwarding
797
798         gbp pq export
799
800         branch=`git symbolic-ref HEAD`
801         branch=${branch#refs/heads/}
802
803         case "$branch" in
804         */*) fail "unexpected branch $branch" ;;
805         esac
806
807         git branch -f qc/$branch
808         git checkout qc/$branch
809         git add debian/patches
810         git commit -m 'Commit patch queue'
811 }
812
813 t-git-pseudo-merge () {
814         # like   git merge -s ours
815         if [ ! "$git_pseuomerge_opts" ]; then
816                 if git merge --help \
817                  | grep -q allow-unrelated-histories; then
818                         git_pseuomerge_opts='--allow-unrelated-histories'
819                 fi
820                 git_pseuomerge_opts+=' -s ours'
821         fi
822         git merge $git_pseuomerge_opts "$@"
823 }
824
825 t-gbp-example-prep-no-ff () {
826         t-tstunt-parsechangelog
827         t-archive example 1.0-1
828         t-git-none
829         t-worktree 1.0
830
831         cd example
832
833         t-dgit fetch
834
835         git checkout -b patch-queue/quilt-tip-2 patch-queue/quilt-tip
836         gbp pq rebase
837
838         echo '/* some comment */' >>src.c
839         git add src.c
840         git commit -m 'Add a comment to an upstream file'
841
842         t-gbp-unapplied-pq2qc
843
844         t-commit 'some updates' 1.0-2
845 }
846
847 t-gbp-example-prep () {
848         t-gbp-example-prep-no-ff
849
850         t-git-pseudo-merge \
851                 -m 'Pseudo-merge to make descendant of archive' \
852                 remotes/dgit/dgit/sid
853 }
854
855 t-commit () {
856         local msg=$1
857         v=${2:-${majorv:-1}.$revision}
858         dch --force-distribution -v$v --distribution ${3:-unstable} "$1"
859         git add debian/changelog
860         debcommit
861         revision=$(( ${revision-0} + 1 ))
862 }
863
864 t-git-config () {
865         git config --global "$@"
866 }
867
868 t-drs () {
869         export DGIT_TEST_TROOT=$troot
870  t-git-config dgit-distro.test-dummy.git-url "ext::$troot/drs-git-ext %S "
871  t-git-config dgit-distro.test-dummy.git-check true
872  t-git-config dgit-distro.test-dummy.git-create true
873  t-git-config dgit-distro.test-dummy.dgit-tag-format new,old,maint
874         cp $troot/gnupg/{dd.gpg,dm.gpg,dm.txt} $tmp/.
875         cp $troot/suites $tmp/.
876         cp $troot/suites $tmp/suites-master
877
878         export t_check_pushed_master=t-check-pushed-master
879
880         drs_dispatch=$tmp/distro=test-dummy
881         mkdir $drs_dispatch
882
883         if [ "x$DGIT_TEST_INTREE" != x ]; then
884                 ln -sf "$DGIT_TEST_INTREE" $drs_dispatch/dgit-live
885         fi
886
887         ln -sf $tmp/git $drs_dispatch/repos
888         ln -sf $tmp/suites $tmp/suites-master $tmp/dm.txt $drs_dispatch/
889         mkdir -p $drs_dispatch/keyrings
890         ln -sf $tmp/dd.gpg $drs_dispatch/keyrings/debian-keyring.gpg
891         ln -sf $tmp/dm.gpg $drs_dispatch/keyrings/debian-maintainers.gpg
892         ln -sf /bin/true $drs_dispatch/policy-hook
893 }
894
895 t-newtag () {
896  export tagpfx=archive/test-dummy
897  t-git-config dgit-distro.test-dummy.dgit-tag-format new,maint
898 }
899 t-oldtag () {
900  export tagpfx=test-dummy
901  t-git-config dgit-distro.test-dummy.dgit-tag-format old
902 }
903
904 t-dsd () {
905         t-drs
906  t-git-config dgit-distro.test-dummy.ssh "$troot/dsd-ssh"
907  t-git-config dgit-distro.test-dummy.git-check ssh-cmd
908  t-git-config dgit-distro.test-dummy.git-create true
909  t-git-config dgit-distro.test-dummy.git-url \
910                 "ext::$troot/dsd-ssh X %S /dgit/test-dummy/repos"
911
912  t-git-config dgit-distro.test-dummy.diverts.drs /drs
913  t-git-config dgit-distro.test-dummy/drs.ssh "$troot/ssh"
914  t-git-config dgit-distro.test-dummy/drs.git-url $tmp/git
915  t-git-config dgit-distro.test-dummy/drs.git-check ssh-cmd
916  t-git-config dgit-distro.test-dummy/drs.git-create ssh-cmd
917
918         echo 'no-such-package* drs' >$drs_dispatch/diverts
919 }
920
921 t-policy-admin () {
922         ${DGIT_INFRA_PFX}dgit-repos-admin-debian --repos $tmp/git "$@"
923 }
924
925 t-policy-nonexist () {
926         ln -sf no-such-file-or-directory $drs_dispatch/policy-hook
927 }
928
929 t-make-hook-link () {
930         local hook=$1 # in infra/
931         local linkpath=$2
932         hook=${DGIT_INFRA_PFX}$hook
933         case $hook in
934         */*)    ;;
935         *)      hook=`type -P $hook` ;;
936         esac
937         ln -sf "$hook" $linkpath
938 }
939
940 t-policy () {
941         local policyhook=$1
942         t-make-hook-link $policyhook $drs_dispatch/policy-hook
943 }
944
945 t-debpolicy () {
946         t-dsd
947         t-policy dgit-repos-policy-debian
948
949         mkdir $tmp/git
950         t-policy-admin create-db
951 }
952
953 t-policy-periodic () {
954         ${DGIT_REPOS_SERVER_TEST-dgit-repos-server} \
955                 test-dummy $drs_dispatch '' --cron
956 }
957
958 t-restrict () {
959         local restriction=$1
960         (cd $root; t-restriction-$restriction >&2)
961 }
962
963 t-dependencies () {
964         : "Hopefully installed: $*"
965 }
966
967 t-chain-test () {
968         local ct=$1
969         local d=${0%/*}
970         cd $root
971         export DGIT_TEST_TESTNAME="$testname"
972         export DGIT_TEST_TMPBASE="$tmpbase"
973         export ADTTMP=$tmp
974         exec "$d/$ct"
975 }       
976
977 t-alt-test () {
978         local t=${0##*/}
979         t-${t%%-*}
980         t-chain-test "${t#*-}"
981 }
982
983 case "$0" in
984 */gnupg) ;;
985 *)      t-setup-import gnupg    ;;
986 esac